import java.awt.Shape;
import java.awt.geom.Arc2D;
import java.awt.geom.GeneralPath;
import java.awt.geom.Line2D;


public class Surface_Kay extends EmptyCadObject {

	GeneralPath gp = null;

	public Surface_Kay()
	{
		setName("Surface");
		setNumberOfPoints(3);
		setGeometryTyp(EmptyCadObject.GEOMETRY_2D_POLYGON);
		setFillable(true);
		initEnvironment();
	}

	public Surface_Kay(String name)
	{
		setName(name);
		setNumberOfPoints(3);
		setGeometryTyp(EmptyCadObject.GEOMETRY_2D_POLYGON);
		setFillable(true);
		initEnvironment();
	}

	public Shape initShape(int panelID, double scale)
	{	
		double x1, y1, x2, y2, x3, y3;
		gp = new GeneralPath();
		
		for(int i=0; i<vertexList.size(); i=i+3) {
			gp.moveTo((float)(vertexList.get(i).getX() * scale), (float)(vertexList.get(i).getY() * scale));
			gp.lineTo((float)(vertexList.get(i+1).getX() * scale), (float)(vertexList.get(i+1).getY() * scale));
			gp.lineTo((float)(vertexList.get(i+2).getX() * scale), (float)(vertexList.get(i+2).getY() * scale));
			gp.lineTo((float)(vertexList.get(i).getX() * scale), (float)(vertexList.get(i).getY() * scale));
//			gp.closePath();
		}
		shapeXY = gp;

		for(int i=0; i<vertexList.size(); i=i+3) {
			gp.moveTo((float)(vertexList.get(i).getZ() * scale), (float)(vertexList.get(i).getY() * scale));
			gp.lineTo((float)(vertexList.get(i+1).getZ() * scale), (float)(vertexList.get(i+1).getY() * scale));
			gp.lineTo((float)(vertexList.get(i+2).getZ() * scale), (float)(vertexList.get(i+2).getY() * scale));
			gp.lineTo((float)(vertexList.get(i).getZ() * scale), (float)(vertexList.get(i).getY() * scale));
//			gp.closePath();
		}
		shapeZY = gp;

		for(int i=0; i<vertexList.size(); i=i+3) {
			gp.moveTo((float)(vertexList.get(i).getX() * scale), (float)(vertexList.get(i).getZ() * scale));
			gp.lineTo((float)(vertexList.get(i+1).getX() * scale), (float)(vertexList.get(i+1).getZ() * scale));
			gp.lineTo((float)(vertexList.get(i+2).getX() * scale), (float)(vertexList.get(i+2).getZ() * scale));
			gp.lineTo((float)(vertexList.get(i).getX() * scale), (float)(vertexList.get(i).getZ() * scale));
//			gp.closePath();
		}
		shapeXZ = gp;

		
		if(panelID==0)
			shape = shapeXY;
		else if(panelID==1)
			shape = shapeZY;
		else
			shape = shapeXZ;

		return shape;
	}
	
	public int getLineTyp() {
		return EmptyCadObject.GEOMETRY_2D_POLYGON;
	}

}
